#include <QtCore/QString>
#include <QtTest/QtTest>
#include <QStringBuilder>

class TestPerf : public QObject
{
    Q_OBJECT

public:
    TestPerf();

private Q_SLOTS:
    void concat();
    void concat_data();
};

TestPerf::TestPerf()
{
}

void TestPerf::concat()
{
	QFETCH(bool, useStringBuilder);
	QString result;

	QString a("a"), b("b"), c("c"), d("d"), e("e"), f("f"), g("g"), h("h"), i("i"),
	j("j"), k("k"), l("l"), m("m"), n("n"), o("o"), p("p"), q("q"), r("r"), s("s"),
	t("t"), u("u"), v("v"), w("w"), x("x"), y("y"), z("z");

	if (useStringBuilder)
	{
		QBENCHMARK {
			result = a % b % c % d % e % f % g % h % i % j % k % l % m % n % o % p % q % r % s % t % u % v % w % x % y % z;
		}
	}
	else
	{
		QBENCHMARK {
			result = a + b + c + d + e + f + g + h + i + j + k + l + m + n + o + p + q + r + s + t + u + v + w + x + y + z;
		}
	}
}

void TestPerf::concat_data()
{
	QTest::addColumn<bool>("useStringBuilder");
	QTest::newRow("Use QStringBuilder") << true;
	QTest::newRow("Don't use QStringBuilder") << false;
}

QTEST_APPLESS_MAIN(TestPerf);

#include "tst_testperf.moc"
